document.addEventListener('DOMContentLoaded', function() {
  const captchaText = document.getElementById('captchaText');
  const captchaInput = document.getElementById('captcha');
  const postForm = document.getElementById('postForm');
  const postsContainer = document.getElementById('postsContainer');

  function generateCaptcha() {
    const chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    let captcha = '';
    for (let i = 0; i < 6; i++) {
      captcha += chars.charAt(Math.floor(Math.random() * chars.length));
    }
    captchaText.textContent = captcha;
  }

  function loadPosts() {
    // Load posts from database and display them
    // This is a placeholder for actual database interaction
    const posts = [
      {
        id: 1,
        author: 'John Doe',
        date: '2023-10-01 12:00',
        content: 'This is a sample post.',
        likes: 10,
        dislikes: 2,
        replies: [
          {
            author: 'Jane Doe',
            date: '2023-10-01 12:30',
            content: 'This is a sample reply.'
          }
        ]
      }
    ];

    postsContainer.innerHTML = '';
    posts.forEach(post => {
      const postElement = document.createElement('div');
      postElement.className = 'post';
      postElement.innerHTML = `
        <div class="post-header">
          <span class="post-author">${post.author}</span>
          <span class="post-date">${post.date}</span>
        </div>
        <div class="post-content">${post.content}</div>
        <div class="post-actions">
          <button onclick="likePost(${post.id})">Like (${post.likes})</button>
          <button onclick="dislikePost(${post.id})">Dislike (${post.dislikes})</button>
          <button onclick="showReplyForm(${post.id})">Reply</button>
          <button onclick="sharePost(${post.id})">Share</button>
        </div>
        <div id="replyForm${post.id}" class="reply-form">
          <input type="text" id="replyName${post.id}" placeholder="Your Name" required>
          <textarea id="replyContent${post.id}" placeholder="Your Reply" required></textarea>
          <button onclick="submitReply(${post.id})">Submit Reply</button>
        </div>
        <div class="replies">
          ${post.replies.map(reply => `
            <div class="reply">
              <div class="reply-header">
                <span class="reply-author">${reply.author}</span>
                <span class="reply-date">${reply.date}</span>
              </div>
              <div class="reply-content">${reply.content}</div>
            </div>
          `).join('')}
        </div>
      `;
      postsContainer.appendChild(postElement);
    });
  }

  postForm.addEventListener('submit', function(event) {
    event.preventDefault();
    if (captchaInput.value === captchaText.textContent) {
      // Submit post to database
      // This is a placeholder for actual database interaction
      alert('Post submitted successfully!');
      postForm.reset();
      generateCaptcha();
      loadPosts();
    } else {
      alert('Invalid captcha!');
    }
  });

  window.likePost = function(postId) {
    // Like post in database
    alert('Liked post ' + postId);
  };

  window.dislikePost = function(postId) {
    // Dislike post in database
    alert('Disliked post ' + postId);
  };

  window.showReplyForm = function(postId) {
    const replyForm = document.getElementById('replyForm' + postId);
    replyForm.style.display = 'block';
  };

  window.submitReply = function(postId) {
    const replyName = document.getElementById('replyName' + postId).value;
    const replyContent = document.getElementById('replyContent' + postId).value;
    if (replyName && replyContent) {
      // Submit reply to database
      alert('Reply submitted successfully!');
      loadPosts();
    } else {
      alert('Please fill in all fields!');
    }
  };

  window.sharePost = function(postId) {
    // Share post on social media
    alert('Shared post ' + postId);
  };

  generateCaptcha();
  loadPosts();
});